#include <limits.h>
#include <dos.h>
#ifdef LSI_C
#include <machine.h>
#define disable() di()
#define enable() ei()
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

union REGS r;
struct SREGS sr;

unsigned myatou(const char *s)
{
	long l;
	l = strtol(s, NULL, 0);
	if (l < 0 || l > UINT_MAX) {
		fprintf(stderr, "parameter error!\n");
		exit(-1);
	}
	return (unsigned)l;
}

unsigned prm_al;
unsigned prm_cx;
unsigned prm_dx;
int pregs;
int opth;

int myopt(int argc, char *argv[])
{
	while(argc > 0) {
		char *s = *argv;
		size_t n;
		n = s ? strlen(s) : 0;
		if (n > 3) {
			if (memcmp("al=", s, 3)==0) { prm_al = myatou(s+3); ++pregs; }
			if (memcmp("cx=", s, 3)==0) { prm_cx = myatou(s+3); ++pregs; }
			if (memcmp("dx=", s, 3)==0) { prm_dx = myatou(s+3); ++pregs; }
		}
		if (strcmp(s, "-?")==0) opth = 1;
		
		--argc;
		++argv;
	}
}

int main(int argc, char *argv[])
{
	unsigned char far *hrcnt = MK_FP(0, 0x4f1);

	myopt(argc-1, argv+1);
	if (opth) {
		printf("usage: i1c80_1 [al=0x?? cx=0x???? dx=0x????]\n");
		return 0;
	}

	if (pregs) {
		printf("invoke int 1Ch ah=81h (AL=%02x CX=%04x DX=%04x)\n", prm_al, prm_cx, prm_dx);
		r.x.ax = prm_al;
		r.x.cx = prm_cx;
		r.x.dx = prm_dx;
		r.h.ah = 0x81;
		int86x(0x1c, &r, &r, &sr);
	}
	
	printf("Press any key to exit...\n");
	printf("\x1b[>5h");
	do {
		
		r.h.al = 0xff;
		r.x.cx = r.x.dx = 0xffff;
		
		r.h.ah = 0x80;
		int86x(0x1c, &r, &r, &sr);
		printf("\rint 1Ch AH=80h ... AL=%02x CX:DX=%04x:%04x 0000:04F1=%02x:%02x:%02x", r.h.al, r.x.cx, r.x.dx, hrcnt[0], hrcnt[1], hrcnt[2]);
		r.h.ah = 5;		/* check and get keystroke */
		int86x(0x18, &r, &r, &sr);
	} while(r.h.bh == 0);
	printf("\x1b[>5l\n");
	return 0;

}

